#include <sdsl/suffixarrays.hpp>
#include <iostream> 
#include <iomanip>

using namespace std;
using namespace sdsl;

int main(){
	const unsigned char * text = (unsigned char*)"swissmissmissing";
	// create compressed suffix array of the text
	csa_sada_theo<> csa1(text);
	cout << text << endl;
	cout << "---" << endl;
	cout << "   i SA[i] T_{SA[i]}" << endl;
	// print out the result using the [] operator
	for(size_t i=0; i<csa1.size(); ++i){
		cout<< setw(4) << i << " " << setw(5) <<csa1[i]<<" "<< text+csa1[i] <<endl;
	}
	cout<<endl;

//	csa_sada_prac<>::size_type b,e;
//	algorithm::backward_search(csa1, (unsigned char*)"mis", 3, b, e);
//	cout<<b<<" "<<e<<endl;

}

/*
Output:  

swissmissmissing
---
   i SA[i] T_{SA[i]}
   0    15 g
   1    13 ing
   2    10 issing
   3     6 issmissing
   4     2 issmissmissing
   5     9 missing
   6     5 missmissing
   7    14 ng
   8    12 sing
   9     8 smissing
  10     4 smissmissing
  11    11 ssing
  12     7 ssmissing
  13     3 ssmissmissing
  14     0 swissmissmissing
  15     1 wissmissmissing

*/
