#include <sdsl/cst_sada.hpp> 
#include <sdsl/cst_sct.hpp>
#include <iostream>
#include <fstream>

using namespace std;
using namespace sdsl;

typedef cst_sct<>		    cst_type;
typedef cst_type::size_type size_type;
typedef cst_type::node_type node_type;

void dfs(node_type v, const cst_type &cst){
	// print node information
//	cout<<"node "<<v<<"  depth = "<<cst.depth(v)<<endl;
	size_type i=1;
	node_type c;
	while( (c = cst.ith_child(v,i)) != cst.root() ){
		dfs(c, cst);
		++i;
	}
}

template<class T>
size_type space_of(const T &ds){
	ofstream out;
	out.open("/dev/null", ios::binary | ios::trunc);
	if(out){
		size_type written_bytes = ds.serialize(out);
		out.close();
		return written_bytes;
	}else{
		cerr<<"could not create of open file csa_test.dat"<<endl;
		return 0;
	}

}

int main(){
	const unsigned char *text = (const unsigned char*)"abaaba";
	cst_type cst(text);
	cerr<<"bp = "<<cst.bp<<endl;

	dfs(cst.root(), cst);	
	
	node_type v = cst.root();
	unsigned char *pattern = (unsigned char*)"ba";
	for(size_type i=0, char_pos; i<strlen((char*)pattern);){
		v = cst.child(v, pattern[i], char_pos);
		if(v==cst.root()) break;
		cerr<<"v="<<v<<" c="<<pattern[i]<<endl;
		size_type i2 = cst.depth(v);
		while(++i < i2){
			size_type cc = cst.csa.char2comp[pattern[i]];
			char_pos = cst.csa.psi[char_pos];
			if( char_pos < cst.csa.C[cc] and char_pos >= cst.csa.C[cc+1]  ){
				v = cst.root();
				goto finish;
			}
		}
	}
finish:;	
	if(v != cst.root()){
		cerr<<"found "<< cst.leaves_in_the_subtree(v) <<" occurence of "<<pattern<<" v="<<v<<endl;
		for(size_type i=1; i<= cst.depth(v);++i)
			cerr<<cst.edge(v,i);
		cerr<<endl;
	}

	ofstream out;
	cerr<<"Space of data structures in bytes:"<<endl;
	cerr<<"cst "<<space_of(cst)<<endl;	
	cerr<<"csa "<<space_of(cst.csa)<<endl;	
	cerr<<"lcp "<<space_of(cst.lcp)<<endl;	
	cerr<<"bp  "<<space_of(cst.bp)<<endl;	
}
