#include <sdsl/int_vector.hpp>
#include <iostream>

using namespace sdsl;

int main(){
	// Create an empty vector for integers
	int_vector<> v;
	// Create a vector containing 100 5-bit unsigned integers. 
    // All integers are initialized to 13.
	int_vector<5> v5(100, 13); 
	for(size_t i=0; i<10; ++i) 
		std::cout << v5[i] << std::endl; // output the first 10 elements of v5
	std::cout<<"length of v5 = "<<v5.size()<<std::endl;
	std::cout<<"length of v = "<<v.size()<<std::endl;
	v.resize(6);
	std::cout<<"length of v = "<<v.size()<<std::endl;

	for(size_t i=0;i<v.size();++i)
		v[i] = i;
	// output all values of v: 0 1 2 3 4 5 6
	std::cout<<v<<std::endl;
	std::cout<<"Width of integers stored in v = "<<(int)v.getIntWidth()<<std::endl;
	std::cout<<"Width of integers stored in v5 = "<<(int)v5.getIntWidth()<<std::endl;
	// change the width of integers to the half of 64
	v.setIntWidth(32);
	std::cout<<"length of v has doubled to "<<v.size()<<std::endl;
	// no we get this elements in v
	std::cout<<v<<std::endl;	

	int_vector<> w = v; // assign v to the new vector w
	std::cout<<w<<std::endl;	
	w.setIntWidth(64);
	std::cout<<"w = "<<w<<std::endl;	
	std::cout<<"v = "<<v<<std::endl;
	// resize w
	w.resize(3);
	std::cout<<"w = "<<w<<std::endl;
	w.resize(6);
	// we cannot be sure, that the added elements are initialized to 0
	std::cout<<"w = "<<w<<std::endl;
}

