#include <sdsl/testutils.hpp>
#include <sdsl/csa_sada_prac.hpp>

#include <boost/filesystem.hpp>
#if BOOST_WORKAROUND( __GNUC__, < 3)
typedef boost::test_tools::output_test_stream onullstream_type;
#else
#include <boost/test/utils/nullstream.hpp>
typedef boost::onullstream onullstream_type;
#endif

#include <string>

using namespace sdsl;
using namespace boost::filesystem;
using namespace std;

const uint16_t sample_psi = 128;
const uint16_t sample_sa = 2;
typedef csa_sada_prac<enc_vector_prac<coder::fibonacci, sample_psi,32>, sample_sa,32> tCSAFib;
typedef csa_sada_prac<enc_vector_prac<coder::elias_delta, sample_psi,32>, sample_sa, 32> tCSAEd;

int main(int argc, void** argv){

	path test_file_dir("../../test_cases/small/");
	for(directory_iterator dir_it(test_file_dir), end; dir_it != end; ++dir_it){
		if( is_regular( dir_it->status() ) ){// is regular file in boost 1.36.0
			string test_case = dir_it->path().leaf();	
			string path_name = dir_it->path().file_string();
			string test_case_dir = test_file_dir.directory_string();

			char *text = NULL;
			int_vector<32> sa;
			uint64_t n;

			cerr<<"try to open "<<path_name<<" "<<test_case<<" "<<endl;
			if( (n=file::readText((path_name).c_str(),text)) ){
				sa.resize(n);
				algorithm::calculate_sa((const unsigned char*)text,n,sa);
			}else{
				continue;
			}
			tCSAEd csa_ed((const int_vector<32>)sa, (const unsigned char*)text);
			delete [] text;
			uint64_t k=0,k1=0;
			stop_watch stopwatch;

			stopwatch.start();		
			for(uint64_t i=0; i<n; ++i){
				k += sa[i];
			}
			stopwatch.stop();		
			cout << stopwatch.getUserTime()/(double)n << " ";

			stopwatch.start();		
			for(uint64_t i=0; i<n; ++i){
				k1 += csa_ed[i];
			}
			stopwatch.stop();		
			cout << stopwatch.getUserTime()/(double)n << " ";
			assert(k == k1);			
			cout<<endl;
		}	
	}
}
