#include "coder.hpp"

namespace sdsl{

namespace coder{	



uint64_t fibonacci::decode_prefix_sum(const uint64_t *data, const size_type start_idx, size_type n){
	if(n==0)
		return 0;
//	return decode<true,false,int*>(data, start_idx, n);
	data += (start_idx >> 6);
	size_type i = 0;
    int32_t	bits_to_decode = 0;
	uint64_t w = 0, value = 0;
	int16_t buffered = 0, read = start_idx & 0x3F, shift = 0;
	uint16_t temp=0;
	uint64_t carry=0;
	i = bit_magic::b11Cnt(*data & ~bit_magic::Li1Mask[read], carry);
	if( i<n ){
		uint64_t oldcarry;
		w = 0;
		do{
			oldcarry = carry;
			i += (temp = bit_magic::b11Cnt(*(data+(++w)), carry));
		}while(i<n);
		bits_to_decode +=  ((w-1)<<6) + bit_magic::i11BP(*(data+w), n-(i-temp), oldcarry) + 65 - read;
		w = 0;
	}else{ // i>=n
		bits_to_decode = bit_magic::i11BP(*data >> read, n)+1;
	}
	if(bits_to_decode == n<<1) // TODO: comparisson between unsigned and signed int
		return n;
	if(bits_to_decode == (n<<1)+1 )
		return n+1;
	i = 0;
//	while( bits_to_decode > 0 or buffered > 0){// while not all values are decoded
	do{
		while(buffered < 64 and bits_to_decode > 0){
			w |= (((*data)>>read)<<buffered);
			if( read >= buffered ){
				++data;
				buffered += 64-read;
				bits_to_decode -= (64-read);
				read = 0;
			}else{// read buffered
				read += 64-buffered;
				bits_to_decode -= (64-buffered);
				buffered = 64;
			}
			if( bits_to_decode < 0 ){
				buffered += bits_to_decode;
				w &= bit_magic::Li1Mask[buffered];
				bits_to_decode = 0;
			}
		}
		if(!i){// try do decode multiple values
			if( (w&0xFFFFFF)==0xFFFFFF ){
				value += 12;
				w >>= 24;
				buffered -= 24;
				if((w&0xFFFFFF)==0xFFFFFF){
					value += 12;
					w >>= 24;
					buffered -= 24;
				}
			}
			do{
				temp = bit_magic::Fib2bin_0_16_greedy[w&0xFFFF];
				if( (shift=(temp>>11)) > 0 ){
					value += (temp & 0x7FFULL);
					w >>= shift;
					buffered -= shift;
				}
				else{
					value += bit_magic::Fib2bin_0_95[w&0xFFF];
					w >>= 12;
					buffered -= 12;
					i = 1;
					break;
//					goto decode_single;
				}
			}while(buffered>15);
		}else{// i > 0
//decode_single:			
			value += bit_magic::Fib2bin_0_95[(i<<12) | (w&0xFFF)];
			shift  = bit_magic::Fib2binShift[w&0x1FFF];
			if( shift > 0){ // if end of decoding
				w >>= shift;
				buffered -= shift;
				i = 0;
			}else{// not end of decoding
				w >>= 12;
				buffered -= 12;
				++i;
			}
		}
	}while( bits_to_decode > 0 or buffered > 0 );
	return value;
}

uint64_t fibonacci::decode_prefix_sum(const uint64_t *data, const size_type start_idx, const size_type end_idx, size_type n){
	return decode_prefix_sum(data, start_idx, n);
}

uint64_t elias_delta::decode_prefix_sum(const uint64_t *data, const size_type start_idx, const size_type end_idx, size_type n){
	const uint64_t *lastdata = data + ((end_idx+63) >> 6);
	data += (start_idx >> 6);
	uint64_t w = 0, value = 0;
	int16_t buffered = 0, read = start_idx & 0x3F;
	size_type i = 0;
	if(n + read <= 64 ){
		if( ((*data >> read)&bit_magic::Li1Mask[n]) == bit_magic::Li1Mask[n] )
			return n;
	}else{// n+read > 64
		if( (*data >> read) == bit_magic::Li1Mask[64-read] ){// all bits are set to 1
			value = 64-read;
			++data;
			n -= (64-read);
			read = 0;
			while(n >= 64){
				if(*data == 0xFFFFFFFFFFFFFFFFULL){
					value += 64;
					++data;
					n -= 64;
				}else
					goto start_decoding;
			}
			// 0 <= n <= 64
			if( (*data&bit_magic::Li1Mask[n]) == bit_magic::Li1Mask[n] )
				return value + n;
		}
	}
	
start_decoding:
	while(i<n){
		while(buffered < 64 and data < lastdata){
fill_buffer:			
			w |= (((*data)>>read)<<buffered);
			if( read >= buffered ){
				++data;
				buffered += 64-read;
				read = 0;
			}else{// read buffered
				read += 64-buffered;
				buffered = 64;
			}
		}
/*		if(w==0xFFFFFFFFFFFFFFFFULL){
			i += 64;
			value += 64;
			if(i >= n)
				return value - (i-n);
			buffered = 0;
			w = 0;
		//	continue;
			goto fill_buffer;
		}
*/		
//		uint32_t rbp = (w == 0xFFFFFFFFFFFFFFFFULL)?64:bit_magic::r1BP(~w);
		uint32_t rbp = bit_magic::r1BP(~w);
		if(rbp > 0){
			i += rbp;
			value += rbp;
			if(i >= n){// decoded too much
				return value - (i-n); // return corrected value
			}
			assert(buffered >= rbp);
			buffered -= rbp;
			w >>= rbp;
			if(buffered<16) 
//				continue;
				goto fill_buffer;
		}
//		assert(w!=0xFFFFFFFFFFFFFFFFULL);
//		else
		{// i < n
begin_decode:
			uint32_t psum = bit_magic::EliasDeltaPrefixSum[w&0x0000FFFF];	
			if( !psum or i+((psum>>16)&0x00FF) > n ){
				if( w==0 ){// buffer is not full
					w |= (((*data)>>read)<<buffered);
					if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					if(!w){ w |= (((*data)>>read)<<buffered);
						if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					}
				}
//				assert(w>0);
				uint16_t len_1_len = bit_magic::r1BP(w); // read length of length
				buffered -= (len_1_len+1);
				w >>= (len_1_len+1);
				if( len_1_len > buffered ){// buffer is not full
					w |= (((*data)>>read)<<buffered);
					if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					if(len_1_len > buffered ){ w |= (((*data)>>read)<<buffered);
						if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					}				
				}
//				assert(len_1_len <= buffered);
				uint16_t len_1 = (w&bit_magic::Li1Mask[len_1_len]) + (1ULL << len_1_len) - 1;
				buffered -= len_1_len;
				w >>= len_1_len;
				if( len_1 > buffered ){// buffer is not full
					w |= (((*data)>>read)<<buffered);
					if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					if(len_1 > buffered ){ w |= (((*data)>>read)<<buffered);
						if( read >= buffered ){ ++data; buffered += 64-read; read = 0; }else{ read += 64-buffered; buffered = 64;};
					}				
				}
//				if( len_1 > buffered ){
//					std::cerr<<"len_1="<<len_1<<" buffered = "<<buffered<<std::endl;
//				}
//				assert(len_1 <= buffered);
				value	+= (w&bit_magic::Li1Mask[len_1]) + (1ULL << (len_1));
				buffered -= len_1;
				w >>= len_1;
				++i;	
				if(i==n)
					return value;
				if(buffered>=16)
					goto begin_decode;
			}else{
				value += (psum&0x0000FFFF);
				i += ((psum>>16)&0x00FF);
				if(i==n)
					return value;
				buffered -= (psum>>24);
				w >>= (psum>>24);
				if(buffered>=16)
					goto begin_decode;
			}
		}
//		std::cerr<<i<<" / "<<n<<std::endl;
	};
//	std::cerr<<value<<std::endl;
	return value;
}


uint64_t elias_delta::decode_prefix_sum(const uint64_t *data, const size_type start_idx, size_type n){
	data += (start_idx >> 6);
	uint64_t value = 0;
	size_type i = 0;
	uint8_t offset = start_idx & 0x3F;

	if( n < 24 ){
	if(n + offset <= 64 ){
		if( ((*data >> offset)&bit_magic::Li1Mask[n]) == bit_magic::Li1Mask[n] )
			return n;
	}else{// n+offset > 64
		if( (*data >> offset) == bit_magic::Li1Mask[64-offset] ){// all bits are set to 1
			value = 64-offset;
			++data;
			n -= (64-offset);
			offset = 0;
			while(n >= 64){
				if(*data == 0xFFFFFFFFFFFFFFFFULL){
					value += 64;
					++data;
					n -= 64;
				}else{
					uint8_t temp = bit_magic::r1BP(~(*data));
					value += temp;
					n -= temp;
					offset = temp;
					goto start_decoding;
				}
			}
			// 0 <= n <= 64
			if( (*data&bit_magic::Li1Mask[n]) == bit_magic::Li1Mask[n] )
				return value + n;
		}//else{
			
//		}
	}
	}
	
start_decoding:
	
	while( i < n ){// while not all values are decoded
		// n-i values to decode
		if( ((*data>>offset)&0xF)==0xF  ){
			uint8_t maxdecode = n-i > 63 ? 63 : n-i;
			uint8_t rbp = bit_magic::r1BP(~bit_magic::readInt(data, offset,maxdecode));
			i += rbp;
			value += rbp;
			if(rbp+offset>=64){ ++data; offset = (rbp+offset)&0x3F; }else{ offset += rbp; }
			if(rbp == maxdecode)
				continue;
		}
		while( i < n ){
			uint32_t psum = bit_magic::EliasDeltaPrefixSum[bit_magic::readInt(data, offset, 16)];
//			if( psum == 0 or i+((psum>>16)&0x00FF) > n ){ // value does not fit in 16 bits
			if( psum == 0 ){ // value does not fit in 16 bits
				goto decode_single;
			}
			else if( i+((psum>>16)&0x00FF) > n ){ // decoded too much 
				if(n-i <= 8){
					psum = bit_magic::EliasDeltaPrefixSum8bit[bit_magic::readInt(data, offset, 8) | ((n-i-1)<<8)];
					if( psum > 0 ){
						value += (psum&0xF);
						i += ((psum>>4)&0xF);
						offset += (psum>>8);
						if(offset>=64){offset&=0x3F; ++data; }
					}
				}
				break;
			}
			else{
				value += (psum&0x0000FFFF);
				i += ((psum>>16)&0x00FF);
				offset += (psum>>24);
				if(offset>=64){ offset&=0x3F; ++data; }
			}
		}
		if(i<n){
decode_single:			
			i++;	
			uint16_t len_1_len = bit_magic::readUnaryIntAndMove(data, offset); // read length of length of x
			uint16_t len_1 	=  bit_magic::readIntAndMove(data, offset, len_1_len) + (1ULL << len_1_len) - 1;
			value	+= bit_magic::readIntAndMove(data, offset, len_1) + (1ULL << (len_1));
		}
	}
	return value;
}

/*
 // naive decoding method
uint64_t elias_delta::decode_prefix_sum(const uint64_t *data, const size_type start_idx, size_type n){
	data += (start_idx >> 6);
	uint64_t value = 0;
	size_type i = 0;
	uint8_t offset = start_idx & 0x3F;//, maxdecode;
	while( i++ < n ){// while not all values are decoded
			uint16_t len_1_len = bit_magic::readUnaryIntAndMove(data, offset); // read length of length of x
			uint16_t len_1 	=  bit_magic::readIntAndMove(data, offset, len_1_len) + (1ULL << len_1_len) - 1;
			value	+= bit_magic::readIntAndMove(data, offset, len_1) + (1ULL << (len_1));
	}
	return value;
}
*/


uint64_t ternary::decode_prefix_sum(const uint64_t *data, const size_type start_idx, size_type n){
	if(n==0) return 0;
	return decode<true,false,int*>(data, start_idx, n);
/*	data += (start_idx >> 6);
	size_t i = 0;
    int32_t	bits_to_decode = 0;
	uint64_t w = 0, value = 0, v;
	int8_t buffered = 0, read = start_idx & 0x3F, shift = 0;
	uint32_t j = 0;
	uint64_t temp=0;
// calculate number of bits to decode
	i = bit_magic::eB11Cnt(*data & ~bit_magic::Li1Mask[read]);
	if( i<n ){
		bits_to_decode = 64-read;
		j = 0;
		do{
			i += (temp = bit_magic::eB11Cnt(*(data+(++j))));
		}while(i<n);
		bits_to_decode +=  ((j-1)<<6) + bit_magic::eI11BP(*(data+j), n-(i-temp)) + 1;
	}else{ // i>=n
		bits_to_decode = bit_magic::eI11BP(*data >> read, n)+1;
	}
//	std::cerr<<"bits_to_decode"<<bits_to_decode<<std::endl;
	temp = 0;
	while( bits_to_decode > 0 or buffered > 0){// while not all values are decoded
		while(buffered < 16 and bits_to_decode > 0){
			w |= (((*data)>>read)<<buffered);
			if( read >= buffered ){
				++data;
				buffered += 64-read;
				bits_to_decode -= (64-read);
				read = 0;
			}else{// read buffered
				read += 64-buffered;
				bits_to_decode -= (64-buffered);
				buffered = 64;
			}
		}
		if( bits_to_decode < 0 ){
			buffered += bits_to_decode;
			w &= bit_magic::Li1Mask[buffered];	
			bits_to_decode = 0;
		}
		v = bit_magic::Trny2bin_0_16_greedy[w&0xFFFF];
Ueberarbeiten: siehe fibonacci coder
		if( ((v>>13)==7) && (w&0xC000)!=0xC000  ){//not end of decoding 
			temp  *= 6561; // temp *= 3**8 
			temp += v&0x1FFF;
			w >>= 16;
			buffered -= 16;
		}else{// end of decoding 
			shift = ((v>>13)+1)<<1;
//std::cerr<<"end of decoding; shift = "<<(int)shift<<std::endl;			
			w >>= shift;
			buffered -= shift;
			temp *= bit_magic::powerOf3[v>>13];
			temp += v&0xFFF;
			value += temp;
			temp = 0;
		}
	}
	return value;
*/
}

} // end namespace coder

/*
const size_t util::rankNaive(const int_vector<1> &v, size_t i, bool b){
	if( i > v.size() ) 
		i = v.size();
	const uint64_t *data = v.data();
	size_t res = 0;
	size_t j = 0;
	for(j=0; j < i/64;++j){
		res += bit_magic::b1Cnt(*(data++));
	}	
	uint64_t r = i & 0x3F;
	res += bit_magic::b1Cnt(bit_magic::Li1Mask[r]&(*data)); 
	if( b )
		return res;
	else
		return i-res;
}
*/

/*
std::string SDSBitVector::operator[](const char* range)const{
	std::stringstream ss(range);
	size_t begin_idx, end_idx;
	char dot1, dot2;
	if ( (ss >> begin_idx) and (ss >> dot1) 
			       and (ss >> dot2) and (ss>> end_idx) 
			       and dot1 == '.' and dot2 == '.' )
	{ 
		if(end_idx < capacity() && begin_idx < capacity()){
			if(end_idx > begin_idx){
				std::string result(end_idx-begin_idx+1,'0');
				for(size_t idx = begin_idx; idx <= end_idx; ++idx)
					if( this->getBit(idx) )
						result[idx-begin_idx] = '1';	
				return result;
			}else{
				std::string result(begin_idx-end_idx+1,'0');
				for(size_t idx = begin_idx+1; idx >= end_idx+1; --idx){
					if( this->getBit(idx-1) )
						result[begin_idx+1-idx] = '1';	
				}
				return result;
			}
		}
		else 
			return "Index out of bounce.";
	}
	return "Invalid range format.";
};
*/



} // end namespace sdsl
