#include <sdsl/coder.hpp>
#include <iostream>
#include <iomanip>

using std::cout;
using std::endl;

int main(){
	cout<<"const uint32_t bit_magic::EliasDeltaPrefixSum[]={\n";
	uint64_t maxvalue = 0, maxoffset = 0, maxnumbers = 0;
	for(uint64_t x=0; x < (1<<16); ++x){
		const uint64_t *w = &x; // copy of x
		uint64_t value = 0;
		uint16_t numbers = 0, offset=0, offset2=0; 
		while( (x >> offset) !=0){
			uint64_t len_1_len = sdsl::bit_magic::readUnaryInt(w, offset), len = 0;
			if( len_1_len == 0 ){
				offset += 1;
				value += 1;
				++numbers;
			}else{
				offset2 = offset + len_1_len +1;
				len = sdsl::bit_magic::readInt(w, offset2, len_1_len) + (1ULL << len_1_len);
				offset2 += len_1_len;
				if( offset2 + len-1 <= 16 ){
					value += sdsl::bit_magic::readInt(w, offset2, len-1) + (1ULL << (len-1));
					offset = offset2 + len - 1;
					++numbers;
				}
				else break;
			}
		}
		uint32_t result=0;// the highest 8 bit equal the shift/offset, the second highest 8 bit equal the number of decoded values, 
						  // and the last 16 bit equals value of decoded prefix sum
		result = (offset << 24) | (numbers<<16) | value;
		if(value>0)
			assert(offset > 0  and numbers > 0 and offset<=16 and numbers <= 16);
		cout<<"0x"<<std::hex<<std::setfill('0')<<std::setw(8)<<result;
		if(x+1!=(1<<16)) cout<<",";
		if(x%8==7)
			cout<<endl;
		if( maxvalue < value )
			maxvalue = value;
		if( maxoffset < offset )
			maxoffset = offset;
		if( maxnumbers < numbers)
			maxnumbers = numbers;
	}
	cout<<"};\n";
	std::cout<<std::dec<<"maxvalue = "<<maxvalue<<" maxoffset = "<<maxoffset<<" maxnumbers = "<<maxnumbers<<std::endl;
	return 0;
}
